#ifndef LOGINMACLABELWIDGET_H
#define LOGINMACLABELWIDGET_H

#include "parsec_mac_qt5_global.h"

#include <QWidget>

#include <parsec/mac.h>

#include "macfilemodel.h"

namespace Ui
{
    class LoginMacLabelWidget;
    class NewLoginMacLabelWidget;
}

class QVBoxLayout;
class QHBoxLayout;

namespace ParsecQt5
{
//---------------------------------------------------------
class PARSEC_MAC_QT5_EXPORT LoginMacLabelWidget : public QWidget
{

Q_OBJECT

public:

    LoginMacLabelWidget( uid_t /*uid*/
                       , QWidget * /*parent*/ = nullptr
                       , bool /*showRoles*/ = true );
    LoginMacLabelWidget( uid_t /*uid*/
                       , bool /*showRoles*/
                       , bool /*theme*/
                       , QWidget * /*parent*/ = nullptr);
    virtual ~LoginMacLabelWidget();
    QVBoxLayout * buttonLayout();
    QHBoxLayout *newButtonLayout();

    void setUid( uid_t /*uid*/ );
    mac_lev_t level() const;
    mac_cat_t categories() const;
    char* malloc_mac_label_text();
    bool isValid();
    bool isSuitable();
    bool isVariability();

    bool loadLastChoice();
    bool saveChoice() const;

    QStringList getSumacArguments() const; //#4420
    QStringList getSumacCommand() const;

    bool isIntegrityLevelVisible() const;
    void setIntegrityLevelVisible( bool );
    void setMaxIntegrityLevel();

    bool editable() const;
    void setEditable(bool editable);

    bool themed() const;

public slots:

    void setVisibleRoles( bool );

private:

    Ui::LoginMacLabelWidget *_ui;
    Ui::NewLoginMacLabelWidget *_newUi;
    MacFileModel *_userModel;
    MacFileModel *_adminModel;
    uid_t _uid;
    bool _editable;
    bool _theme = false;

    bool levelComboBoxSetUid(uid_t uid);
    bool integrityComboBoxSetUid(uid_t uid);
    bool categoryListWidgetSetUid(uid_t uid);
};

//---------------------------------------------------------
}

#endif // LOGINMACLABELWIDGET_H
